// Code generated by protoc-gen-go.
// source: code.justin.tv/release/trace/pbmsg/memcached/memcached.proto
// DO NOT EDIT!

/*
Package memcached is a generated protocol buffer package.

It is generated from these files:
	code.justin.tv/release/trace/pbmsg/memcached/memcached.proto

It has these top-level messages:
*/
package memcached

import proto "github.com/golang/protobuf/proto"
import fmt "fmt"
import math "math"

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

type Command int32

const (
	// Default value - unset. Probably an administrative
	// command like STAT.
	Command_UNKNOWN_COMMAND Command = 0
	// Set means "store this data."
	Command_SET Command = 1
	// Add means "store this data, but only if the server
	// doesn't already have data for this key."
	Command_ADD Command = 2
	// Replace means "store this data, but only if the
	// server *does* have data for this key."
	Command_REPLACE Command = 3
	// Append means "add this data to an existing key
	// after existing data." Append does not come with an
	// expiration time.
	Command_APPEND Command = 4
	// Prepend means "add this data to an existing key
	// before existing data." Prepend does not come with
	// an expiration time.
	Command_PREPEND Command = 5
	// Compare-and-set means "Store this data, if and only
	// if no one else has updated since I last fetched
	// it."
	Command_CAS Command = 6
	// Get retrieves one or more keys. If no_reply is set
	// to true, then the server will not respond in the
	// case of cache misses, so it is the client's
	// responsibility to match up which requested keys
	// actually got a VALUE response if they ask for
	// multiple keys at once.
	Command_GET Command = 7
	// Gets is like Get, but asks for the cas_unique to be
	// sent along with the response.
	Command_GETS Command = 8
	// Delete forcibly removes a key.
	Command_DELETE Command = 9
	// Incr means "increment this key by this amount." The
	// server returns the new value of the key.
	Command_INCR Command = 10
	// Decr means "decrement this key by this amount." The
	// server returns the new value of the key.
	Command_DECR Command = 11
)

var Command_name = map[int32]string{
	0:  "UNKNOWN_COMMAND",
	1:  "SET",
	2:  "ADD",
	3:  "REPLACE",
	4:  "APPEND",
	5:  "PREPEND",
	6:  "CAS",
	7:  "GET",
	8:  "GETS",
	9:  "DELETE",
	10: "INCR",
	11: "DECR",
}
var Command_value = map[string]int32{
	"UNKNOWN_COMMAND": 0,
	"SET":             1,
	"ADD":             2,
	"REPLACE":         3,
	"APPEND":          4,
	"PREPEND":         5,
	"CAS":             6,
	"GET":             7,
	"GETS":            8,
	"DELETE":          9,
	"INCR":            10,
	"DECR":            11,
}

func (x Command) Enum() *Command {
	p := new(Command)
	*p = x
	return p
}
func (x Command) String() string {
	return proto.EnumName(Command_name, int32(x))
}
func (x *Command) UnmarshalJSON(data []byte) error {
	value, err := proto.UnmarshalJSONEnum(Command_value, data, "Command")
	if err != nil {
		return err
	}
	*x = Command(value)
	return nil
}
func (Command) EnumDescriptor() ([]byte, []int) { return fileDescriptor0, []int{0} }

func init() {
	proto.RegisterEnum("code.justin.tv.release.trace.pbmsg.memcached.Command", Command_name, Command_value)
}

var fileDescriptor0 = []byte{
	// 223 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x09, 0x6e, 0x88, 0x02, 0xff, 0x54, 0x8e, 0xdd, 0x4a, 0x03, 0x31,
	0x10, 0x85, 0xad, 0xad, 0xdd, 0x76, 0xf6, 0xc2, 0x21, 0xbe, 0x85, 0x48, 0xf6, 0x05, 0xbc, 0x89,
	0xc9, 0x20, 0x62, 0x9b, 0x2e, 0xdd, 0x8a, 0xe0, 0x8d, 0xac, 0xd9, 0xe0, 0x0f, 0xa6, 0x29, 0xbb,
	0xd1, 0x07, 0xf1, 0x89, 0xcd, 0x14, 0xa9, 0xf4, 0xee, 0x9b, 0x39, 0xe7, 0x1b, 0x06, 0xae, 0x5d,
	0xec, 0xbc, 0xfc, 0xf8, 0x1a, 0xd2, 0xfb, 0x56, 0xa6, 0xef, 0xaa, 0xf7, 0x9f, 0xbe, 0x1d, 0x7c,
	0x95, 0xfa, 0xd6, 0xf9, 0x6a, 0xf7, 0x12, 0x86, 0xd7, 0x2a, 0xf8, 0xe0, 0x5a, 0xf7, 0xe6, 0xbb,
	0x7f, 0x92, 0xbb, 0x3e, 0xa6, 0x28, 0xae, 0x8e, 0x6d, 0xf9, 0x67, 0xcb, 0xbd, 0x2d, 0xf7, 0xb6,
	0x3c, 0x38, 0x97, 0x3f, 0x23, 0x28, 0x74, 0x0c, 0xa1, 0xdd, 0x76, 0xe2, 0x02, 0xce, 0x1f, 0xec,
	0xbd, 0x5d, 0x3d, 0xda, 0x67, 0xbd, 0x5a, 0x2e, 0x95, 0x35, 0x78, 0x22, 0x0a, 0x18, 0x37, 0xb4,
	0xc1, 0x11, 0x83, 0x32, 0x06, 0x4f, 0x45, 0x09, 0xc5, 0x9a, 0xea, 0x85, 0xd2, 0x84, 0x63, 0x01,
	0x30, 0x55, 0x75, 0x4d, 0xb9, 0x3a, 0xe1, 0xa0, 0xce, 0x09, 0x0f, 0x67, 0x5c, 0xd7, 0xaa, 0xc1,
	0x29, 0xc3, 0x6d, 0x3e, 0x50, 0x88, 0x19, 0x4c, 0x32, 0x34, 0x38, 0x63, 0xc9, 0xd0, 0x82, 0x36,
	0x84, 0x73, 0xde, 0xde, 0x59, 0xbd, 0x46, 0x60, 0x32, 0x94, 0xa9, 0xbc, 0x29, 0x9f, 0xe6, 0x87,
	0x0f, 0x7f, 0x03, 0x00, 0x00, 0xff, 0xff, 0x3b, 0xd2, 0xdc, 0x25, 0x0e, 0x01, 0x00, 0x00,
}
