variable "twitch_aws_access_key" {}
variable "twitch_aws_secret_key" {}

module "common_local" {
  source = "../../../modules/variables/twitch-web-dev/"
}

variable "subnet_name"{
  default = "cohesion-staging-subnet"
}

module "rds-subnet-group"{
  twitch_aws_access_key = "${var.twitch_aws_access_key}"
  twitch_aws_secret_key = "${var.twitch_aws_secret_key}"

  source = "../../lib/subnet-group.20160512"

  cluster_identifier      = "${var.subnet_name}"
  subnet_ids              = "${module.common_local.data_a},${module.common_local.data_b},${module.common_local.data_c}"
}

output "rds-subnet-group-id"{
  value = "${module.rds-subnet-group.rds-subnet-group-id}"
}